/**
 * Copyright (C) 2003-2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

package sync4j.syncclient.demo;

import java.awt.Button;
import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.CheckboxGroup;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.ScrollPane;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import java.util.Hashtable;
import java.util.Vector;

import sync4j.foundation.pdi.contact.Contact;
import sync4j.foundation.pdi.contact.Email;
import sync4j.foundation.pdi.contact.Note;
import sync4j.foundation.pdi.contact.Phone;
import sync4j.foundation.pdi.contact.Title;
import sync4j.foundation.pdi.contact.WebPage;
import sync4j.foundation.pdi.common.*;

/**
 * A form containing all the fields concerning a contact.
 * This form will be a subpanel for ContactModify and ContactNew
 *
 * @author Fabio Maggi @ Funambol
 * @author Alessandro Morandi, Giorgio Orsi
 * @version $Id: ContactForm.java,v 1.6.2.1 2005/01/26 16:03:20 fabius Exp $
 */
public class ContactForm extends Panel
implements ActionListener,
           MouseListener ,
           ConfigurationParameters {

    //---------------------------------------------------------- Constants

    // Note this is NOT the actual size of the
    // TextField. It's just a way to avoid
    // horizontal scrolling
    public static final int TF_COLUMNS = 10 ;

    //---------------------------------------------------------- Private data

    //
    // The window containing this panel
    //
    private MainWindow     mw                  = null ;

    //
    // The currently displayed tab (general,personal,business)
    //
    private String         currentTab          = null           ;

    private TextField      tf2                 = null           ;
    private TextField      tf3                 = null           ;
    private TextField      tf4                 = null           ;
    private TextField      tf5                 = null           ;
    private TextField      tf6                 = null           ;
    private TextField      tf7                 = null           ;
    private TextField      tf11                = null           ;
    private TextField      tf13                = null           ;
    private TextField      tf14                = null           ;
    private TextField      tf15                = null           ;
    private TextField      tf16                = null           ;
    private TextField      tf17                = null           ;
    private TextField      tf19                = null           ;
    private TextField      tf20                = null           ;
    private TextField      tf22                = null           ;
    private TextField      tf23                = null           ;
    private TextField      tf24                = null           ;
    private TextField      tf25                = null           ;
    private TextField      tf31                = null           ;
    private TextField      tf32                = null           ;
    private TextField      tf33                = null           ;
    private TextField      tf34                = null           ;
    private TextField      tf35                = null           ;
    private TextField      tf36                = null           ;
    private TextField      tf37                = null           ;
    private TextField      tf38                = null           ;
    private TextField      tf39                = null           ;
    private TextField      tf41                = null           ;
    private TextField      tf42                = null           ;
    private TextField      tf45                = null           ;
    private TextField      tf46                = null           ;
    private TextField      tf47                = null           ;
    private TextField      tf48                = null           ;
    private TextField      tf49                = null           ;
    private TextField      tf50                = null           ;

    private CheckboxGroup  cbGroup             = null           ;
    private Button         butGeneral          = null           ;
    private Button         butPersonal         = null           ;
    private Button         butBusiness         = null           ;
    private CardLayout     cardLayout          = null           ;
    private Panel          fieldPanel          = null           ;
    private ScrollPane     scrollGeneralPane   = null           ;
    private ScrollPane     scrollPersonalPane  = null           ;
    private ScrollPane     scrollBusinessPane  = null           ;

    private Language       ln                  = new Language() ;

    //---------------------------------------------------------- Public methods

    public String getBirthdayDate () {
        return tf19.getText();
    }

    /**
     * Creates the form subpanel.
     *
     * @param mw the window containing this panel
     */
    public ContactForm(MainWindow mw) {

        Panel generalPanel = null;
        Panel personalPanel = null;
        Panel businessPanel = null;

        //
        // Generic Labels
        //
        Label lb2  = null;
        Label lb3  = null;
        Label lb4  = null;
        Label lb5  = null;
        Label lb6  = null;
        Label lb7  = null;
        Label lb11 = null;

        //
        // Personal Labels
        //
        Label lb13 = null;
        Label lb14 = null;
        Label lb15 = null;
        Label lb16 = null;
        Label lb17 = null;
        Label lb19 = null;
        Label lb20 = null;
        Label lb22 = null ;
        Label lb23 = null ;
        Label lb24 = null ;
        Label lb25 = null ;

        //
        // Business Labels
        //
        Label lb31 = null ;
        Label lb32 = null ;
        Label lb33 = null ;
        Label lb34 = null ;
        Label lb35 = null ;
        Label lb36 = null ;
        Label lb37 = null ;
        Label lb38 = null ;
        Label lb39 = null ;
        Label lb41 = null ;
        Label lb42 = null ;
        Label lb45 = null ;
        Label lb46 = null ;
        Label lb47 = null ;
        Label lb48 = null ;
        Label lb49 = null ;
        Label lb50 = null ;

        this.mw = mw;

        Panel buttonMenu = new Panel();
        buttonMenu.setLayout(new GridLayout(1,3));

        butGeneral = new Button       (ln.getString ("general")  ) ;
        butGeneral.setActionCommand   ("general"                 ) ;
        butGeneral.addActionListener  (this                      ) ;
        butGeneral.setEnabled         (false                     ) ;
        butPersonal = new Button      (ln.getString ("personal") ) ;
        butPersonal.setActionCommand  ("personal"                ) ;
        butPersonal.addActionListener (this                      ) ;
        butBusiness = new Button      (ln.getString ("business") ) ;
        butBusiness.setActionCommand  ("business"                ) ;
        butBusiness.addActionListener (this                      ) ;

        buttonMenu.add (butGeneral  ) ;
        buttonMenu.add (butPersonal ) ;
        buttonMenu.add (butBusiness ) ;

        //
        // Generic Textfields
        //
        tf2  = new TextField (TF_COLUMNS ) ;
        tf3  = new TextField (TF_COLUMNS ) ;
        tf4  = new TextField (TF_COLUMNS ) ;
        tf5  = new TextField (TF_COLUMNS ) ;
        tf6  = new TextField (TF_COLUMNS ) ;
        tf7  = new TextField (TF_COLUMNS ) ;
        tf11 = new TextField (TF_COLUMNS ) ;

        tf2.addMouseListener  (this ) ;
        tf3.addMouseListener  (this ) ;
        tf4.addMouseListener  (this ) ;
        tf5.addMouseListener  (this ) ;
        tf6.addMouseListener  (this ) ;
        tf7.addMouseListener  (this ) ;
        tf11.addMouseListener (this ) ;

        //
        // Personal Textfields
        //
        tf13 = new TextField (TF_COLUMNS ) ;
        tf14 = new TextField (TF_COLUMNS ) ;
        tf15 = new TextField (TF_COLUMNS ) ;
        tf16 = new TextField (TF_COLUMNS ) ;
        tf17 = new TextField (TF_COLUMNS ) ;
        tf19 = new TextField (TF_COLUMNS ) ;
        tf20 = new TextField (TF_COLUMNS ) ;
        tf22 = new TextField (TF_COLUMNS ) ;
        tf23 = new TextField (TF_COLUMNS ) ;
        tf24 = new TextField (TF_COLUMNS ) ;
        tf25 = new TextField (TF_COLUMNS ) ;

        tf13.addMouseListener (this) ;
        tf14.addMouseListener (this) ;
        tf15.addMouseListener (this) ;
        tf16.addMouseListener (this) ;
        tf17.addMouseListener (this) ;
        tf19.addMouseListener (this) ;
        tf20.addMouseListener (this) ;
        tf22.addMouseListener (this) ;
        tf23.addMouseListener (this) ;
        tf24.addMouseListener (this) ;
        tf25.addMouseListener (this) ;

        //
        // Business Textfields
        //
        tf31 = new TextField (TF_COLUMNS) ;
        tf32 = new TextField (TF_COLUMNS) ;
        tf33 = new TextField (TF_COLUMNS) ;
        tf34 = new TextField (TF_COLUMNS) ;
        tf35 = new TextField (TF_COLUMNS) ;
        tf36 = new TextField (TF_COLUMNS) ;
        tf37 = new TextField (TF_COLUMNS) ;
        tf38 = new TextField (TF_COLUMNS) ;
        tf39 = new TextField (TF_COLUMNS) ;
        tf41 = new TextField (TF_COLUMNS) ;
        tf42 = new TextField (TF_COLUMNS) ;
        tf45 = new TextField (TF_COLUMNS) ;
        tf46 = new TextField (TF_COLUMNS) ;
        tf47 = new TextField (TF_COLUMNS) ;
        tf48 = new TextField (TF_COLUMNS) ;
        tf49 = new TextField (TF_COLUMNS) ;
        tf50 = new TextField (TF_COLUMNS) ;

        tf31.addMouseListener (this) ;
        tf32.addMouseListener (this) ;
        tf33.addMouseListener (this) ;
        tf34.addMouseListener (this) ;
        tf35.addMouseListener (this) ;
        tf36.addMouseListener (this) ;
        tf37.addMouseListener (this) ;
        tf38.addMouseListener (this) ;
        tf39.addMouseListener (this) ;
        tf41.addMouseListener (this) ;
        tf42.addMouseListener (this) ;
        tf45.addMouseListener (this) ;
        tf46.addMouseListener (this) ;
        tf47.addMouseListener (this) ;
        tf48.addMouseListener (this) ;
        tf49.addMouseListener (this) ;
        tf50.addMouseListener (this) ;

        //
        // General Labels
        //
        lb2  = new Label (ln.getString ("title"           )) ;
        lb3  = new Label (ln.getString ("first_name"      )) ;
        lb4  = new Label (ln.getString ("middle_name"     )) ;
        lb5  = new Label (ln.getString ("last_name"       )) ;
        lb6  = new Label (ln.getString ("suffix"          )) ;
        lb7  = new Label (ln.getString ("nickname"        )) ;
        lb11 = new Label (ln.getString ("note"            )) ;

        //
        // Personal Labels
        //
        lb13 = new Label (ln.getString ("street"          )) ;
        lb14 = new Label (ln.getString ("city"            )) ;
        lb15 = new Label (ln.getString ("state"           )) ;
        lb16 = new Label (ln.getString ("postal_code"     )) ;
        lb17 = new Label (ln.getString ("country"         )) ;
        lb19 = new Label (ln.getString ("birthday"        )) ;
        lb20 = new Label (ln.getString ("cell_phone"      )) ;
        lb22 = new Label (ln.getString ("home_phone"      )) ;
        lb23 = new Label (ln.getString ("home_phone2"     )) ;
        lb24 = new Label (ln.getString ("home_fax"        )) ;

        lb25 = new Label (ln.getString ("gen_phone"       )) ;

        //
        // Business Labels
        //
        lb31 = new Label (ln.getString ("street"          )) ;
        lb32 = new Label (ln.getString ("city"            )) ;
        lb33 = new Label (ln.getString ("state"           )) ;
        lb34 = new Label (ln.getString ("postal_code"     )) ;
        lb35 = new Label (ln.getString ("country"         )) ;
        lb36 = new Label (ln.getString ("role"            )) ;
        lb37 = new Label (ln.getString ("job_title"       )) ;
        lb38 = new Label (ln.getString ("company"         )) ;
        lb39 = new Label (ln.getString ("department"      )) ;
        lb41 = new Label (ln.getString ("business_phone"  )) ;
        lb42 = new Label (ln.getString ("business_phone2" )) ;
        lb45 = new Label (ln.getString ("business_fax"    )) ;
        lb46 = new Label (ln.getString ("pager_number"    )) ;
        lb47 = new Label (ln.getString ("email1"          )) ;
        lb48 = new Label (ln.getString ("email2"          )) ;
        lb49 = new Label (ln.getString ("email3"          )) ;
        lb50 = new Label (ln.getString ("webpage"         )) ;

        //
        // Generic panel
        //
        generalPanel = new Panel();
        generalPanel.setLayout(new GridLayout(17, 2));

        generalPanel.add (lb2          ) ;
        generalPanel.add (tf2          ) ;
        generalPanel.add (lb3          ) ;
        generalPanel.add (tf3          ) ;
        generalPanel.add (lb4          ) ;
        generalPanel.add (tf4          ) ;
        generalPanel.add (lb5          ) ;
        generalPanel.add (tf5          ) ;
        generalPanel.add (lb6          ) ;
        generalPanel.add (tf6          ) ;
        generalPanel.add (lb7          ) ;
        generalPanel.add (tf7          ) ;
        generalPanel.add (lb11         ) ;
        generalPanel.add (tf11         ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;
        generalPanel.add (new Label () ) ;

        //
        // Personal panel
        //
        personalPanel = new Panel();
        personalPanel.setLayout(new GridLayout(22, 2));

        personalPanel.add (lb13         ) ;
        personalPanel.add (tf13         ) ;
        personalPanel.add (lb14         ) ;
        personalPanel.add (tf14         ) ;
        personalPanel.add (lb15         ) ;
        personalPanel.add (tf15         ) ;
        personalPanel.add (lb16         ) ;
        personalPanel.add (tf16         ) ;
        personalPanel.add (lb17         ) ;
        personalPanel.add (tf17         ) ;
        personalPanel.add (lb19         ) ;
        personalPanel.add (tf19         ) ;
        personalPanel.add (lb25         ) ;
        personalPanel.add (tf25         ) ;
        personalPanel.add (lb20         ) ;
        personalPanel.add (tf20         ) ;
        personalPanel.add (lb22         ) ;
        personalPanel.add (tf22         ) ;
        personalPanel.add (lb23         ) ;
        personalPanel.add (tf23         ) ;
        personalPanel.add (lb24         ) ;
        personalPanel.add (tf24         ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;
        personalPanel.add (new Label () ) ;

        //
        // Business panel
        //
        businessPanel = new Panel();
        businessPanel.setLayout(new GridLayout(27, 2));

        businessPanel.add (lb31         ) ;
        businessPanel.add (tf31         ) ;
        businessPanel.add (lb32         ) ;
        businessPanel.add (tf32         ) ;
        businessPanel.add (lb33         ) ;
        businessPanel.add (tf33         ) ;
        businessPanel.add (lb34         ) ;
        businessPanel.add (tf34         ) ;
        businessPanel.add (lb35         ) ;
        businessPanel.add (tf35         ) ;
        businessPanel.add (lb36         ) ;
        businessPanel.add (tf36         ) ;
        businessPanel.add (lb37         ) ;
        businessPanel.add (tf37         ) ;
        businessPanel.add (lb38         ) ;
        businessPanel.add (tf38         ) ;
        businessPanel.add (lb39         ) ;
        businessPanel.add (tf39         ) ;
        businessPanel.add (lb41         ) ;
        businessPanel.add (tf41         ) ;
        businessPanel.add (lb42         ) ;
        businessPanel.add (tf42         ) ;
        businessPanel.add (lb45         ) ;
        businessPanel.add (tf45         ) ;
        businessPanel.add (lb46         ) ;
        businessPanel.add (tf46         ) ;
        businessPanel.add (lb47         ) ;
        businessPanel.add (tf47         ) ;
        businessPanel.add (lb48         ) ;
        businessPanel.add (tf48         ) ;
        businessPanel.add (lb49         ) ;
        businessPanel.add (tf49         ) ;
        businessPanel.add (lb50         ) ;
        businessPanel.add (tf50         ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;
        businessPanel.add (new Label () ) ;

        scrollGeneralPane  = new ScrollPane (ScrollPane.SCROLLBARS_NEVER     ) ;
        scrollGeneralPane.add               (generalPanel                    ) ;

        scrollPersonalPane = new ScrollPane (ScrollPane.SCROLLBARS_NEVER     ) ;
        scrollPersonalPane.add              (personalPanel                   ) ;

        scrollBusinessPane = new ScrollPane (ScrollPane.SCROLLBARS_AS_NEEDED ) ;
        scrollBusinessPane.add              (businessPanel                   ) ;

        fieldPanel = new Panel();
        fieldPanel.setSize(100,100);
        cardLayout = new CardLayout ();
        fieldPanel.setLayout(cardLayout);

        fieldPanel.add (scrollGeneralPane  ,"general"  ) ;
        fieldPanel.add (scrollPersonalPane ,"personal" ) ;
        fieldPanel.add (scrollBusinessPane ,"business" ) ;

        cardLayout.show (fieldPanel, "general" );
        currentTab = "general";

        setLayout(new BorderLayout());

        add (buttonMenu, BorderLayout.NORTH  ) ;
        add (fieldPanel, BorderLayout.CENTER ) ;
    }

    /**
     * Invoked when an action occurs (i.e. a button is pressed).
     *
     * @param evt the occurred action
     */
    public void actionPerformed(ActionEvent evt) {

        if (evt.getActionCommand().equals        ("general"))  {
            butGeneral.setEnabled  (false ) ;
            butPersonal.setEnabled (true  ) ;
            butBusiness.setEnabled (true  ) ;
            cardLayout.show(fieldPanel,"general");
            currentTab = "general";
        } else if (evt.getActionCommand().equals ("personal")) {
            butGeneral.setEnabled  (true  ) ;
            butPersonal.setEnabled (false ) ;
            butBusiness.setEnabled (true  ) ;
            cardLayout.show(fieldPanel,"personal");
            currentTab = "personal";
        } else if (evt.getActionCommand().equals ("business")) {
            butGeneral.setEnabled  (true  ) ;
            butPersonal.setEnabled (true  ) ;
            butBusiness.setEnabled (false ) ;
            cardLayout.show(fieldPanel,"business");
            currentTab = "business";
        }
    }

    /**
     * Invoked when the mouse button has been clicked
     * (pressed and released) on a component.
     * This method adjusts the scrollpanes so that
     * the selected textfield is placed
     * on top of the pane.
     *
     * @param evt the occurred event
     */
    public void mouseClicked(MouseEvent evt) {
        TextField tmptxt = (TextField) evt.getComponent();
        if (currentTab.equals("business")) {
            scrollBusinessPane.setScrollPosition(0,tmptxt.getLocation().y);
        }
    }

    /**
     * Invoked when a mouse button has been
     * pressed on a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mousePressed(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when a mouse button has been
     * released on a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseReleased(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when the mouse enters a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseEntered(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when the mouse exits a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseExited(MouseEvent evt) {
        // do nothing
    }

    //---------------------------------------------------------- Protected methods

    /**
     * Sets the fields with the values contained in the specified Contact object.
     * Used to display the old value of contact
     *
     * @param contact the Contact object which is the source of the values
     */
    protected void setFields(Contact contact) {

        Vector  tmpNoteList    = null ;
        Vector  tmpPhoneList   = null ;
        Vector  tmpTitleList   = null ;
        Vector  tmpEmailList   = null ;
        Vector  tmpWebPageList = null ;

        Note    tmpNote        = null ;
        Phone   tmpPhone       = null ;
        Title   tmpTitle       = null ;
        Email   tmpEmail       = null ;
        WebPage tmpWebPage     = null ;

        String  birthday       = null ;

        //
        // General
        //
        tf2.setText((String) contact.
            getName().getSalutation ().getPropertyValue() ) ;
        tf3.setText((String) contact.
            getName().getFirstName  ().getPropertyValue() ) ;
        tf4.setText((String) contact.
            getName().getMiddleName ().getPropertyValue() ) ;
        tf5.setText((String) contact.
            getName().getLastName   ().getPropertyValue() ) ;
        tf6.setText((String) contact.
            getName().getSuffix     ().getPropertyValue() ) ;
        tf7.setText((String) contact.
            getName().getNickname   ().getPropertyValue() ) ;

        // Note is a vector
        tmpNoteList = contact.getNote();

        if (tmpNoteList.size() > 0) {
            tmpNote = (Note) tmpNoteList.elementAt(0);
            tf11.setText((String) tmpNote.getNote().getPropertyValue());
        } else {
            tf11.setText("");
        }

        //
        // Personal
        //
        tf13.setText((String) contact.getPersonalDetail().
                getAddress().getStreet         ().getPropertyValue() ) ;
        tf14.setText((String) contact.getPersonalDetail().
                getAddress().getCity           ().getPropertyValue() ) ;
        tf15.setText((String) contact.getPersonalDetail().
                    getAddress().getState      ().getPropertyValue() ) ;
        tf16.setText((String) contact.getPersonalDetail().
                    getAddress().getPostalCode ().getPropertyValue() ) ;
        tf17.setText((String) contact.getPersonalDetail().
                    getAddress().getCountry    ().getPropertyValue() ) ;

        birthday = new String("");
        birthday = FieldsHelper.convertDateFromUTC((String) contact.
                            getPersonalDetail().getBirthday());


        if (birthday != null &&  birthday.length() > 10) {
            birthday = birthday.substring(0,10);
        }

        //
        // 01/01/4501 is the dummy date of outlook...
        //
        if (birthday != null && birthday.indexOf("01/01/4501") != -1) {
            birthday = "";
        }

        tf19.setText(birthday);

        tmpPhoneList = contact.getPersonalDetail().getContactDetail().getPhone();

        tf20.setText ("") ;
        tf22.setText ("") ;
        tf23.setText ("") ;
        tf24.setText ("") ;
        tf25.setText ("") ;

        for (int i = 0, l = tmpPhoneList.size(); i < l; i++) {

            tmpPhone = (Phone) tmpPhoneList.elementAt(i);

            if (tmpPhone.getPhoneType        ().equals("MobileTelephoneNumber")) {
                tf20.setText((String) tmpPhone.getNumber().getPropertyValue());
            } else if (tmpPhone.getPhoneType ().equals("HomeTelephoneNumber"))   {
                tf22.setText((String) tmpPhone.getNumber().getPropertyValue());
            } else if (tmpPhone.getPhoneType ().equals("Home2TelephoneNumber"))  {
                tf23.setText((String) tmpPhone.getNumber().getPropertyValue());
            } else if (tmpPhone.getPhoneType ().equals("HomeFaxNumber"))         {
                tf24.setText((String) tmpPhone.getNumber().getPropertyValue());
            } else if (tmpPhone.getPhoneType ().equals("OtherTelephoneNumber"))  {
                tf25.setText((String) tmpPhone.getNumber().getPropertyValue());
            }

        }

        //
        // Business
        //
        tf31.setText((String) contact.getBusinessDetail().
                            getAddress().getStreet().getPropertyValue()     );
        tf32.setText((String) contact.getBusinessDetail().
                            getAddress().getCity().getPropertyValue()       );
        tf33.setText((String) contact.getBusinessDetail().
                            getAddress().getState().getPropertyValue()      );
        tf34.setText((String) contact.getBusinessDetail().
                            getAddress().getPostalCode().getPropertyValue() );
        tf35.setText((String) contact.getBusinessDetail().
                            getAddress().getCountry().getPropertyValue()    );
        tf36.setText((String) contact.getBusinessDetail().
                            getRole().getPropertyValue()                    );
        tf38.setText((String) contact.getBusinessDetail().
                            getCompany().getPropertyValue()                 );
        tf39.setText((String) contact.getBusinessDetail().
                            getDepartment().getPropertyValue()              );

        //
        // Title is a vector. If there is one it is a JobTitle
        //
        tmpTitleList = contact.getBusinessDetail().getTitle();

        if (tmpTitleList.size() > 0) {
            tmpTitle = (Title) tmpTitleList.elementAt(0);
            tf37.setText((String) tmpTitle.getTitle().getPropertyValue());
        } else {
            tf37.setText("");
        }

        tmpPhoneList = contact.getBusinessDetail().getContactDetail().getPhone();

        tmpPhone = null;

        tf41.setText ("") ;
        tf42.setText ("") ;
        tf45.setText ("") ;

        for (int j = 0, l = tmpPhoneList.size(); j < l; j++) {

            tmpPhone = (Phone) tmpPhoneList.elementAt(j);

            if (tmpPhone.getPhoneType       ().equals("BusinessTelephoneNumber")  ) {
                tf41.setText((String) tmpPhone.getNumber().getPropertyValue());
            } else if (tmpPhone.getPhoneType().equals("Business2TelephoneNumber") ) {
                tf42.setText((String) tmpPhone.getNumber().getPropertyValue());
            } else if (tmpPhone.getPhoneType().equals("BusinessFaxNumber")        ) {
                tf45.setText((String) tmpPhone.getNumber().getPropertyValue());
            } else if (tmpPhone.getPhoneType().equals("PagerNumber")              ) {
                tf46.setText((String) tmpPhone.getNumber().getPropertyValue());
            }

        }

        tf47.setText ("" ) ;
        tf48.setText ("" ) ;
        tf49.setText ("" ) ;

        tmpEmailList = contact.getPersonalDetail().getContactDetail().getEmail();

        for (int j = 0, l = tmpEmailList.size(); j < l; j++) {

            tmpEmail = (Email) tmpEmailList.elementAt(j);

            if (tmpEmail.getEmailType().equals("Email1Address")) {
                tf47.setText((String) tmpEmail.
                        getEmailAddress().getPropertyValue());
            }

            if (tmpEmail.getEmailType().equals("Email2Address")) {
                tf48.setText((String) tmpEmail.
                        getEmailAddress().getPropertyValue());
            }

        }

        tmpEmailList = contact.getBusinessDetail().getContactDetail().getEmail();

        for (int j = 0, l = tmpEmailList.size(); j < l; j++) {

            tmpEmail = (Email) tmpEmailList.elementAt(j);

            if (tmpEmail.getEmailType().equals("Email3Address")) {
                tf49.setText((String) tmpEmail.
                        getEmailAddress().getPropertyValue());
            }

        }

        //
        // webPage is a vector.
        // If there is one it is a BusinessWebPage not a Business2WebPage....
        //
        tmpWebPageList = contact.
                            getBusinessDetail().getContactDetail().getWebPage();

        if (tmpWebPageList.size() > 0) {
            tmpWebPage = (WebPage) tmpWebPageList.elementAt(0);
            tf50.setText((String)  tmpWebPage.getWebPageAddress().
                                                    getPropertyValue());
        } else {
            tf50.setText("");
        }

    }

    /**
     * Returns a new Contact object containing the informations
     * set in the textfields.
     * This method also builds the LABELs from the provided addresses,
     * when at least street, city, state, postal code
     * and country are specified.
     *
     * @return the Contact object containing the informations
     * set in the textfields
     */
    protected Contact getFields() {

        Contact contact      = null ;
        String  display_name = ""   ;
        Note    tmpNote      = null ;

        contact = new Contact();

        //
        // General
        //
        contact.getName().getSalutation ().setPropertyValue(tf2.getText() ) ;
        contact.getName().getFirstName  ().setPropertyValue(tf3.getText() ) ;
        contact.getName().getMiddleName ().setPropertyValue(tf4.getText() ) ;
        contact.getName().getLastName   ().setPropertyValue(tf5.getText() ) ;
        contact.getName().getSuffix     ().setPropertyValue(tf6.getText() ) ;
        contact.getName().getNickname   ().setPropertyValue(tf7.getText() ) ;

        if (contact.getName().getLastName().getPropertyValue() != null
            && !contact.getName().getLastName().getPropertyValue().equals(""))  {
            display_name += contact.getName().getLastName().getPropertyValue();
        }

        if (contact.getName().getFirstName().getPropertyValue() != null
            && !contact.getName().getFirstName().getPropertyValue().equals("")) {

            if (!display_name.equals("")) {
                display_name += ",";
            }

            display_name += contact.getName().getFirstName().getPropertyValue();

        }

        if (display_name.equals("")) {
            display_name = "Unknow";
        }

        contact.getName().getDisplayName().setPropertyValue(display_name);

        if (!tf11.getText().equals("")) {
            tmpNote = new Note();
            tmpNote.getNote().setPropertyValue(tf11.getText());
            tmpNote.setNoteType("Body");
            contact.getNote().addElement(tmpNote);
        }

        //
        // Personal
        //
        if (!tf13.getText().equals("")) {
            contact.getPersonalDetail ().getAddress().
                    getStreet    ().setPropertyValue(tf13.getText() ) ;
        }
        if (!tf14.getText().equals("")) {
            contact.getPersonalDetail ().getAddress().
                    getCity      ().setPropertyValue(tf14.getText() ) ;
        }
        if (!tf15.getText().equals("")) {
            contact.getPersonalDetail ().getAddress().
                    getState     ().setPropertyValue(tf15.getText() ) ;
        }
        if (!tf16.getText().equals("")) {
            contact.getPersonalDetail ().getAddress().
                    getPostalCode().setPropertyValue(tf16.getText() ) ;
        }
        if (!tf17.getText().equals("")) {
            contact.getPersonalDetail ().getAddress().
                    getCountry   ().setPropertyValue(tf17.getText() ) ;
        }
        if (!tf19.getText().equals("")) {
            contact.getPersonalDetail ().
                setBirthday(FieldsHelper.convertDateToUTC(tf19.getText()));
        }
        if (!tf20.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf20.getText());
            tmpPhone.setPhoneType("MobileTelephoneNumber");
            contact.getPersonalDetail().getContactDetail().
                                    getPhone().addElement(tmpPhone);
        }

        if (!tf22.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf22.getText());
            tmpPhone.setPhoneType("HomeTelephoneNumber");
            contact.getPersonalDetail().getContactDetail().
                                    getPhone().addElement(tmpPhone);
        }
        if (!tf23.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf23.getText());
            tmpPhone.setPhoneType("Home2TelephoneNumber");
            contact.getPersonalDetail().getContactDetail().
                                    getPhone().addElement(tmpPhone);
        }
        if (!tf24.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf24.getText());
            tmpPhone.setPhoneType("HomeFaxNumber");
            contact.getPersonalDetail().getContactDetail().
                                    getPhone().addElement(tmpPhone);
        }

        if (!tf25.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf25.getText());
            tmpPhone.setPhoneType("OtherTelephoneNumber");
            contact.getPersonalDetail().getContactDetail().
                                    getPhone().addElement(tmpPhone);
        }

        //
        // Business
        //
        if (!tf31.getText().equals("")) {
            contact.getBusinessDetail().getAddress().
                getStreet     ().setPropertyValue(tf31.getText() ) ;
        }
        if (!tf32.getText().equals("")) {
            contact.getBusinessDetail().getAddress().
                getCity       ().setPropertyValue(tf32.getText() ) ;
        }
        if (!tf33.getText().equals("")) {
            contact.getBusinessDetail().getAddress().
                getState      ().setPropertyValue(tf33.getText() ) ;
        }
        if (!tf34.getText().equals("")) {
            contact.getBusinessDetail().getAddress().
                getPostalCode ().setPropertyValue(tf34.getText() ) ;
        }
        if (!tf35.getText().equals("")) {
            contact.getBusinessDetail().getAddress().
                getCountry    ().setPropertyValue(tf35.getText() ) ;
        }
        if (!tf36.getText().equals("")) {
            contact.getBusinessDetail().getRole().
                setPropertyValue(tf36.getText());
        }
        if (!tf38.getText().equals("")) {
            contact.getBusinessDetail().getCompany().
                setPropertyValue(tf38.getText());
        }
        if (!tf39.getText().equals("")) {
            contact.getBusinessDetail().getDepartment().
                setPropertyValue(tf39.getText());
        }
        if (!tf37.getText().equals("")) {
            Title tmpTitle = new Title();
            tmpTitle.getTitle().setPropertyValue(tf37.getText());
            tmpTitle.setTitleType("JobTitle");
            contact.getBusinessDetail().getTitle().addElement(tmpTitle);
        }


        if (!tf41.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf41.getText());
            tmpPhone.setPhoneType("BusinessTelephoneNumber");
            contact.getBusinessDetail().getContactDetail().
                                getPhone().addElement(tmpPhone);
        }
        if (!tf42.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf42.getText());
            tmpPhone.setPhoneType("Business2TelephoneNumber");
            contact.getBusinessDetail().getContactDetail().
                                getPhone().addElement(tmpPhone);
        }

        if (!tf45.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf45.getText());
            tmpPhone.setPhoneType("BusinessFaxNumber");
            contact.getBusinessDetail().getContactDetail().
                                getPhone().addElement(tmpPhone);
        }

        if (!tf46.getText().equals("")) {
            Phone tmpPhone = new Phone();
            tmpPhone.getNumber().setPropertyValue(tf46.getText());
            tmpPhone.setPhoneType("PagerNumber");
            contact.getBusinessDetail().getContactDetail().
                                getPhone().addElement(tmpPhone);
        }

        if (!tf47.getText().equals("")) {
            Email tmpEmail = new Email();
            tmpEmail.getEmailAddress().setPropertyValue(tf47.getText());
            tmpEmail.setEmailType("Email1Address");
            contact.getPersonalDetail().getContactDetail().
                                getEmail().addElement(tmpEmail);
        }
        if (!tf48.getText().equals("")) {
            Email tmpEmail = new Email();
            tmpEmail.getEmailAddress().setPropertyValue(tf48.getText());
            tmpEmail.setEmailType("Email2Address");
            contact.getPersonalDetail().getContactDetail().
                                getEmail().addElement(tmpEmail);
        }
        if (!tf49.getText().equals("")) {
            Email tmpEmail = new Email();
            tmpEmail.getEmailAddress().setPropertyValue(tf49.getText());
            tmpEmail.setEmailType("Email3Address");
            contact.getBusinessDetail().getContactDetail().
                                getEmail().addElement(tmpEmail);
        }

        if (!tf50.getText().equals("")) {
            WebPage tmpWebPage = new WebPage();
            tmpWebPage.getWebPageAddress().setPropertyValue(tf50.getText());
            tmpWebPage.setWebPageType("BusinessWebPage");
            contact.getBusinessDetail().getContactDetail().
                            getWebPage().addElement(tmpWebPage);
        }

        //
        // Personal Label (all fields are mandatory except POBox)
        //
        if (!tf13.getText().equals("") &&
            !tf14.getText().equals("") && !tf15.getText().equals("") &&
            !tf16.getText().equals("") && !tf17.getText().equals("")) {
            contact.getPersonalDetail().getAddress().
                    getLabel().setEncoding("QUOTED-PRINTABLE");
            String tmpPersonalLabel = "";

            //
            // Street
            //
            tmpPersonalLabel += tf13.getText() + "=0D=0A" ;
            //
            // City
            //
            tmpPersonalLabel += tf14.getText() + ", "     ;
            //
            // State
            //
            tmpPersonalLabel += tf15.getText() + " "      ;
            //
            // PostalCode
            //
            tmpPersonalLabel += tf16.getText() + "=0D=0A" ;
            //
            // Country
            //
            tmpPersonalLabel += tf17.getText();
            contact.getPersonalDetail().getAddress().
                    getLabel().setPropertyValue(tmpPersonalLabel);
        }

        //
        // Business Label (all fields are mandatory except POBox and RoomNumber)
        //
        if (!tf31.getText().equals("") &&
            !tf32.getText().equals("") && !tf33.getText().equals("") &&
            !tf34.getText().equals("") && !tf35.getText().equals("")) {
            contact.getBusinessDetail().getAddress().
                    getLabel().setEncoding("QUOTED-PRINTABLE");
            String tmpBusinessLabel = "";

            //
            // Street
            //
            tmpBusinessLabel += tf31.getText() + "=0D=0A" ;
            //
            // City
            //
            tmpBusinessLabel += tf32.getText() + ", "     ;
            //
            // State
            //
            tmpBusinessLabel += tf33.getText() + " "      ;
            //
            // PostalCode
            //
            tmpBusinessLabel += tf34.getText() + "=0D=0A" ;
            //
            // Country
            //
            tmpBusinessLabel += tf35.getText();
            contact.getBusinessDetail().getAddress().getLabel().
                                setPropertyValue(tmpBusinessLabel);
        }

        return contact;
    }

    /**
     * Sets all the textfields to an empty string.
     */
    protected void blankFields() {

        tf2.setText  ("") ;
        tf3.setText  ("") ;
        tf4.setText  ("") ;
        tf5.setText  ("") ;
        tf6.setText  ("") ;
        tf7.setText  ("") ;
        tf11.setText ("") ;
        tf13.setText ("") ;
        tf14.setText ("") ;
        tf15.setText ("") ;
        tf16.setText ("") ;
        tf17.setText ("") ;
        tf19.setText ("") ;
        tf20.setText ("") ;
        tf22.setText ("") ;
        tf23.setText ("") ;
        tf24.setText ("") ;
        tf25.setText ("") ;
        tf31.setText ("") ;
        tf32.setText ("") ;
        tf33.setText ("") ;
        tf34.setText ("") ;
        tf35.setText ("") ;
        tf36.setText ("") ;
        tf37.setText ("") ;
        tf38.setText ("") ;
        tf39.setText ("") ;
        tf41.setText ("") ;
        tf42.setText ("") ;
        tf45.setText ("") ;
        tf46.setText ("") ;
        tf47.setText ("") ;
        tf48.setText ("") ;
        tf49.setText ("") ;
        tf50.setText ("") ;
    }

}